# Roastery #

Roastery is a modern WordPress stack that helps you get started with the best development tools and project structure.

[Roastery](https://brewpixel.com/roastery/)

Much of the philosophy behind Roastery is inspired by Roots and the [Twelve-Factor App](http://12factor.net/) methodology including the [WordPress specific version](https://roots.io/twelve-factor-wordpress/).

## Installation ##

### New project ###

    vagrant up
    vagrant ssh
    cd /srv/www

Replace `example.com` with your project name which will be the domain name and run the following:

    composer create-project brewpixel/roastery --repository=http://satis.brewpixel.com example.com --stability=dev

### Existing roastery based project ###

If you need to run this script again after the project has already been created you can use the following command:

    composer run-script post-create-project-cmd

Once the main repo has been cloned:

composer install
cd public_html/content/themes
git clone CHILD THEME
cd -
cp .env.example .env
cd public_html/
cp wp-config-sample.php wp-config.php
cd -
cd maker/
cp maker-config-sample.php maker-config.php
nano maker-config.php

### Existing roastery based project: Install on staging server ###

Once the main repo has been cloned:

    composer install
    cd public_html/content/themes
    git clone CHILD THEME
    cd -
    cp .env.example .env
    nano .env
    cd public_html/
    cp wp-config-sample.php wp-config.php
    cd -
    cd maker/
    cp maker-config-sample.php maker-config.php
    nano maker-config.php
    
    composer run-script post-create-project-cmd

### The following files should always exist:

- config/env/local/localdev.cfg
- config/env/local/local.php
- maker/maker-config.php
- .env
- public_html/wp-config.php
- wp-cli.yml (a wp-cli.local.yml can also be added (gitignored) to override)


## Making sure repos are updated ##

### Roastery ###

1.
Update roastery

    vagrant up
    vagrant ssh
    cd /srv/templates/roastery
    composer update

2.
In another terminal window, locally and not in vagrant guest. //@TODO: Maybe in future this can be done within vagrant guest?
Commit changes in roastery repo.
Push up to origin repo.

### Satis ###

1.
Update satis

    vagrant up
    vagrant ssh
    cd /srv/www/brewpixel/satis
    php satis/bin/satis build satis.json public_html

2.
In another terminal window, locally and not in vagrant guest. //@TODO: Maybe in future this can be done within vagrant guest?
Commit changes in satis repo.
Push up to origin repo.

3.
ssh into doombar server

    cd /srv/www/brewpixel.com/satis/
    git pull origin master

### brew-puppet-control ###



## Features ##

* Better folder structure
* Dependency management with [Composer](http://getcomposer.org)
* Easy WordPress configuration with environment specific files
* Environment variables with [Dotenv](https://github.com/vlucas/phpdotenv)
* Easy development environments with [Vagrant](http://www.vagrantup.com/)
* Easy server provisioning with [Puppet]() ()

## Requirements ##

* brew-vagrant installed
  - virtual box
  - vagrant


